#!/system/bin/sh
# Please don't hardcode /magisk/modname/... ; instead, please use $MODDIR/...
# Do NOT assume where your module will be located.
# ALWAYS use $MODDIR if you need to know where this script
# and module is placed.
# This will make sure your module will still work
# if Magisk change its mount point in the future
MODDIR=${0%/*}

# This script will be executed in post-fs-data mode
# More info in the main Magisk thread
#mkdir -p /sbin/riru
#mount -o bind /sbin/.core/mirror/data/adb/riru /sbin/riru

# necessary for using mmap in system_server process
#supolicy --live "allow system_server system_server process {execmem}"
# supolicy --live "allow system_server system_server memprotect {mmap_zero}"

# for built-in apps // TODO maybe narrow down the target classes
#supolicy --live "allow coredomain coredomain process {execmem}"

# read configs set in our app
#supolicy --live "allow coredomain app_data_file * *"
#supolicy --live "attradd {system_app platform_app} mlstrustedsubject"

# SELinux permissive support
setenforce 0

# Copy libmemtrack.so
cp -f "/system/lib/libmemtrack.so" "$MODDIR/system/lib/libmemtrack_real.so"
[[ -f "/system/lib64/libmemtrack.so" ]] && cp -f "/system/lib64/libmemtrack.so" "$MODDIR/system/lib64/libmemtrack_real.so"

# Reset context in case
chcon -R u:object_r:system_file:s0 $MODDIR

ZYGOTE_RESTART=/data/misc/riru/bin/zygote_restart
[[ ! -f "/data/misc/riru/config/disable_auto_restart" ]] && $ZYGOTE_RESTART

# read module apk file in zygote
#supolicy --live "allow zygote apk_data_file * *"

. ${MODDIR}/util_functions.sh

start_log_catchers